/**
 * @file    reHDD.h
 * @brief   represent
 * @author  hendrik schutter
 * @date    01.05.2020
 */

#ifndef REHDD_H_
#define REHDD_H_

#define DRYRUN

#include <iostream>
#include <string>
#include <fstream>
#include <tuple>
#include <vector>
#include <time.h>
#include <chrono>
#include <curses.h>
#include <thread>
#include <unistd.h>
#include <mutex>
#include <sys/select.h>
#include<algorithm>
#include <cstring>


using namespace std;

#include "drive.h"
#include "smart.h"
#include "wipe.h"
#include "tui.h"


template <typename T, typename I> T* iterator_to_pointer(I i)
{
    return (&(*i));
}


class reHDD
{
protected:

public:
    reHDD(void);
    void app_logic();

private:

    static void searchDrives(vector <Drive>* pvecDrives);
    static void printDrives(vector <Drive>* pvecDrives);
    static  void filterIgnoredDrives(vector <Drive>* pvecDrives);
    static void addSMARTData(vector <Drive>* pvecDrives);
    static void ThreadScannDevices();
    static void ThreadUserInput();
    static  void handleArrowKey(TUI::UserInput userInput);
    static void filterNewDrives(vector <Drive>* pvecOldDrives, vector <Drive>* pvecNewDrives);

};


#endif  // REHDD_H_